package cz.slabi.david.animaletto;

/**
 * Shows the dialog to set player name and session name.
 * 
 * @author  DavidSlaby
 */
public class GameDialog extends javax.swing.JDialog {
	
	/** 
     * The game dialog to set player name and session name.
     */
	public GameDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		setTitle("Game Settings");
		initComponents();
		fieldPlayer.setText(Main.client.name);
		fieldGame.setText(Main.client.session);
		setSize(270, 120);
		setVisible(true);
	}
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        labelPlayer = new javax.swing.JLabel();
        fieldPlayer = new javax.swing.JTextField();
        labelGame = new javax.swing.JLabel();
        fieldGame = new javax.swing.JTextField();
        buttonCancel = new javax.swing.JButton();
        buttonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridLayout(3, 2, 4, 4));

        labelPlayer.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        labelPlayer.setText("Player:");
        getContentPane().add(labelPlayer);

        fieldPlayer.setText("void");
        getContentPane().add(fieldPlayer);

        labelGame.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        labelGame.setText("Session:");
        getContentPane().add(labelGame);

        fieldGame.setText("void");
        getContentPane().add(fieldGame);

        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCancelActionPerformed(evt);
            }
        });
        getContentPane().add(buttonCancel);

        buttonOK.setText("OK");
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });
        getContentPane().add(buttonOK);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Checks the contents of fields. Saves it and closes dialog if correct,
     * shows a warning if incorrect.
     * 
     * @param evt   the corresponding event
     */
	private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
		String pl = removeDiacritics(fieldPlayer.getText());
		String gm = removeDiacritics(fieldGame.getText());
		if (((pl.indexOf(' ') == -1) && (pl.length() > 0) && (pl.length() <= 24)) &&
				((gm.indexOf(' ') == -1) && (gm.length() > 0) && (gm.length() <= 24))){
			
			Main.client.name = pl;
			Main.client.session = gm;
			Main.client.saveSettings();
			setVisible(false);
			dispose();
		}else{
			javax.swing.JOptionPane.showMessageDialog(this, 
					"Player and Session must not contain spaces, must not be empty " +
					"and must be max. 24 characters long.", 
					"Invalid Player or Session", javax.swing.JOptionPane.ERROR_MESSAGE);
		}
	}//GEN-LAST:event_buttonOKActionPerformed
	
	private String removeDiacritics(String inStr){
        StringBuffer buffer = new StringBuffer();
        for(int i = 0; i < inStr.length(); i++)
        {
            char curChar = inStr.charAt(i);
            
			if (((curChar >= 'a') && (curChar <= 'z')) || ((curChar >= 'A') && (curChar <= 'Z')) || ((curChar >= '0') && (curChar <= '9'))){
				buffer.append(curChar);
			}else{
				buffer.append('_');
			}
        }
        return buffer.toString();
	}
	
    /**
     * Closes the dialog and discards changes.
     * 
     * @param evt   the corresponding event
     */
	private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
		setVisible(false);
		dispose();
	}//GEN-LAST:event_buttonCancelActionPerformed
	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonCancel;
    private javax.swing.JButton buttonOK;
    private javax.swing.JTextField fieldGame;
    private javax.swing.JTextField fieldPlayer;
    private javax.swing.JLabel labelGame;
    private javax.swing.JLabel labelPlayer;
    // End of variables declaration//GEN-END:variables
	
}
