package cz.slabi.david.animaletto;

/**
 * Creates the whole application. Initializes the network
 * client and the main window.
 * 
 * @author DavidSlaby
 */
public class Main {

    /**
     * The client used for network communication and game logics.
     */
	public static Client client;
    
    /**
     * The main window of the application.
     */
    public static MainWindow mainWindow;
    
    /**
     * Is the first method to be run when the application starts. Creates and
     * tests the network client, the main window and initializes the shutdown
     * hook.
     */
    public static void main(String[] args){
        
		client = new Client();

        Card.loadImages();
        
        ShutdownHook shutdownHook = new ShutdownHook();
        shutdownHook.start();
		
		mainWindow = new MainWindow();
    }

}