package cz.slabi.david.animaletto;

/**
 * Shows the dialog to set server IP and port.
 * 
 * @author  DavidSlaby
 */
public class NetworkDialog extends javax.swing.JDialog {
	
	/**
     * Creates the network dialog to set network.
     */
	public NetworkDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		setTitle("Network Settings");
		initComponents();
		fieldServerAddress.setText(Main.client.server.getHostName());
		spinnerServerPort.setValue(Main.client.server.getPort());
		setSize(270, 130);
		setVisible(true);
	}
	
	/** This method is called from within the constructor to
	 * initialize the form.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        labelServerAddress = new javax.swing.JLabel();
        fieldServerAddress = new javax.swing.JTextField();
        labelServerPort = new javax.swing.JLabel();
        spinnerServerPort = new javax.swing.JSpinner();
        buttonCancel = new javax.swing.JButton();
        buttonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridLayout(3, 2, 4, 4));

        labelServerAddress.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        labelServerAddress.setText("Server Address:");
        getContentPane().add(labelServerAddress);

        fieldServerAddress.setText("void");
        getContentPane().add(fieldServerAddress);

        labelServerPort.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        labelServerPort.setText("Server Port:");
        getContentPane().add(labelServerPort);
        getContentPane().add(spinnerServerPort);

        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCancelActionPerformed(evt);
            }
        });
        getContentPane().add(buttonCancel);

        buttonOK.setText("OK");
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });
        getContentPane().add(buttonOK);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Tests new settings and closes the dialog if correct, displays warning if
     * not correct.
     * 
     * @param evt   the corresponding event
     */
	private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
		// TODO add your handling code here:
		try{
			Main.client.setNetwork(fieldServerAddress.getText(),
				(Integer)(spinnerServerPort.getValue()));
			Main.client.testSocket();
			Main.client.saveSettings();
			setVisible(false);
			dispose();
		}catch (Exception e){
			javax.swing.JOptionPane.showMessageDialog(this, "Network was not set properly", 
					"Invalid Network Settings", javax.swing.JOptionPane.ERROR_MESSAGE);
		}
}//GEN-LAST:event_buttonOKActionPerformed

    /**
     * Closes the dialog and discards changes.
     * 
     * @param evt   the corresponding event
     */
	private void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCancelActionPerformed
		// TODO add your handling code here:
		setVisible(false);
		dispose();
	}//GEN-LAST:event_buttonCancelActionPerformed
	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonCancel;
    private javax.swing.JButton buttonOK;
    private javax.swing.JTextField fieldServerAddress;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel labelServerAddress;
    private javax.swing.JLabel labelServerPort;
    private javax.swing.JSpinner spinnerServerPort;
    // End of variables declaration//GEN-END:variables
	
}
