package cz.slabi.david.animaletto;

/**
 * The dialog shown when a game ends. Shows the current score and when all games
 * are finished, announces the name of the winner.
 * 
 * @author  DavidSlaby
 */
public class ScoreDialog extends javax.swing.JDialog {
	
    String winner;
    
	/** 
     * Creates the score dialog.
     */
	public ScoreDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		setSize(360, 200);
        setTitle("Current Score");
        showScore();
        if (Main.client.game < Client.GAMES_COUNT)
            labelInfo.setText("End of game "+String.valueOf(Main.client.game));
        else{
            labelInfo.setText("All games finished. Winner is "+winner+"!");
            Main.mainWindow.logRecord("Winner is "+winner+".");
        }
		setVisible(true);
	}
	
    /**
     * Puts player names and their score to the table.
     */
    private void showScore(){
        int max = 0;
        for (int i = 0; i < Main.client.playerNames.length; i++){
            for (int j = 1; j <= Main.client.game; j++)
                scoreTable.setValueAt
                    (String.valueOf(Main.client.score[i][j]), i, j);
            scoreTable.setValueAt(String.valueOf
                (Main.client.score[i][0]), i, Client.GAMES_COUNT + 1);
            if (Main.client.score[i][0] > max){
                max = Main.client.score[i][0];
                winner = Main.client.playerNames[i];
            }
            scoreTable.setValueAt(Main.client.playerNames[i], i, 0);
        }
    }
    
	/** 
     * This method is called from within the constructor to
	 * initialize the form.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tablePanel = new javax.swing.JScrollPane();
        scoreTable = new javax.swing.JTable();
        panel1 = new java.awt.Panel();
        labelInfo = new java.awt.Label();
        buttonOK = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.PAGE_AXIS));

        scoreTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null},
                {null, null, null, null, null, null}
            },
            new String [] {
                "Player", "Game 1", "Game 2", "Game 3", "Game 4", "Total"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tablePanel.setViewportView(scoreTable);
        scoreTable.getColumnModel().getColumn(0).setResizable(false);
        scoreTable.getColumnModel().getColumn(0).setPreferredWidth(200);
        scoreTable.getColumnModel().getColumn(1).setResizable(false);
        scoreTable.getColumnModel().getColumn(2).setResizable(false);
        scoreTable.getColumnModel().getColumn(3).setResizable(false);
        scoreTable.getColumnModel().getColumn(4).setResizable(false);
        scoreTable.getColumnModel().getColumn(5).setResizable(false);

        getContentPane().add(tablePanel);

        panel1.setLayout(new java.awt.BorderLayout());

        labelInfo.setAlignment(java.awt.Label.CENTER);
        labelInfo.setText("void");
        panel1.add(labelInfo, java.awt.BorderLayout.CENTER);

        buttonOK.setText("OK");
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOKActionPerformed(evt);
            }
        });
        panel1.add(buttonOK, java.awt.BorderLayout.SOUTH);

        getContentPane().add(panel1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Asks client to prepare next game or to clean after end of all games.
     * 
     * @param evt   the corresponding event
     */
	private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        if (Main.client.game < Client.GAMES_COUNT)
    		Main.client.nextGame();
        else
       		Main.client.finishedGames(true);
	}//GEN-LAST:event_formWindowClosed

    /**
     * Closes the dialog.
     * 
     * @param evt   the corresponding event
     */
	private void buttonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOKActionPerformed
		setVisible(false);
		dispose();
	}//GEN-LAST:event_buttonOKActionPerformed
	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonOK;
    private java.awt.Label labelInfo;
    private java.awt.Panel panel1;
    private javax.swing.JTable scoreTable;
    private javax.swing.JScrollPane tablePanel;
    // End of variables declaration//GEN-END:variables
	
}
