package cz.slabi.david.animaletto;

/**
 * The thread performed when exiting the application.
 * 
 * @author DavidSlaby
 */
public class ShutdownHook {
    /**
     * Prepares the thread to be started upon the application exit.
     */
	public void start() {
        MyShutdownHook shutdownHook = new MyShutdownHook();
        Runtime.getRuntime().addShutdownHook(shutdownHook);
    }
}

/**
 * The specific shutdown hook. Stops the network communication if necessary.
 * 
 * @author DavidSlaby
 */
class MyShutdownHook extends Thread {
    
    /**
     * Stops the client network communication if necessary.
     */
	@Override
    public void run() {
		if (!Main.client.socket.isClosed()){
			Main.client.stop();
		}
    }
}